"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mongoLogId = exports.withLogger = exports.useLogger = exports.createLoggerLocator = exports.LoggerProvider = exports.createNoopLogger = void 0;
const react_1 = __importStar(require("react"));
const hadron_app_registry_1 = require("hadron-app-registry");
const noop = () => {
    // noop
};
function createNoopLogger(component = 'NOOP-LOGGER') {
    return {
        log: {
            component,
            get unbound() {
                return this;
            },
            write: () => true,
            info: noop,
            warn: noop,
            error: noop,
            fatal: noop,
            debug: noop,
        },
        debug: noop,
        mongoLogId,
    };
}
exports.createNoopLogger = createNoopLogger;
const LoggerContext = react_1.default.createContext({ createLogger: createNoopLogger });
exports.LoggerProvider = LoggerContext.Provider;
function createLoggerLocator(component) {
    return (0, hadron_app_registry_1.createServiceLocator)(useLogger.bind(null, component), 'createLoggerLocator');
}
exports.createLoggerLocator = createLoggerLocator;
function useLogger(component) {
    const context = react_1.default.useContext(LoggerContext);
    if (!context) {
        throw new Error('Logger service is missing from React context');
    }
    const loggerRef = (0, react_1.useRef)();
    if (!loggerRef.current) {
        loggerRef.current = context.createLogger(component);
    }
    return loggerRef.current;
}
exports.useLogger = useLogger;
function withLogger(ReactComponent, component) {
    const WithLogger = (props) => {
        const logger = useLogger(component);
        return react_1.default.createElement(ReactComponent, { ...props, logger });
    };
    return WithLogger;
}
exports.withLogger = withLogger;
// To avoid dependency on mongodb-log-writer that will pull in a lot of Node.js
// specific code we re-implement mongoLogId in the provider to re-export
//
// Disable prettier so that dupedLogId stays on the same line to be ignored by
// the check-logids script
// prettier-ignore
function mongoLogId(id) {
    return { __value: id };
}
exports.mongoLogId = mongoLogId;
//# sourceMappingURL=provider.js.map